# Using GHC

## Getting started: compiling programs

In this chapter you'll find a complete reference to the GHC command-line syntax, including all 400+ flags. It's a large and complex system, and there are lots of details, so it can be quite hard to figure out how to get started. With that in mind, this introductory section provides a quick introduction to the basic usage of GHC for compiling a Haskell program, before the following sections dive into the full syntax.

Let's create a Hello World program, and compile and run it. First, create a file `hello.hs` containing the Haskell code:

    main = putStrLn "Hello, World!"

To compile the program, use GHC like this:

    $ ghc hello.hs

(where `$` represents the prompt: don't type it). GHC will compile the source file `hello.hs`, producing an object file `hello.o` and an interface file `hello.hi`, and then it will link the object file to the libraries that come with GHC to produce an executable called `hello` on Unix/Linux/Mac, or `hello.exe` on Windows.

By default GHC will be very quiet about what it is doing, only printing error messages. If you want to see in more detail what's going on behind the scenes, add `-v` to the command line.

Then we can run the program like this:

    $ ./hello
    Hello World!

If your program contains multiple modules, then you only need to tell GHC the name of the source file containing the `Main` module, and GHC will examine the `import` declarations to find the other modules that make up the program and find their source files. This means that, with the exception of the `Main` module, every source file should be named after the module name that it contains (with dots replaced by directory separators). For example, the module `Data.Person` would be in the file `Data/Person.hs` on Unix/Linux/Mac, or `Data\Person.hs` on Windows.

## Options overview

GHC's behaviour is controlled by options, which for historical reasons are also sometimes referred to as command-line flags or arguments. Options can be specified in three ways:

### Command-line arguments

An invocation of GHC takes the following form:

    ghc [argument...]

Command-line arguments are either options or file names.

Command-line options begin with `-`. They may not be grouped: `-vO` is different from `-v -O`. Options need not precede filenames: e.g., `ghc *.o -o foo`. All options are processed and then applied to all files; you cannot, for example, invoke `ghc -c -O1 Foo.hs -O2 Bar.hs` to apply different optimisation levels to the files `Foo.hs` and `Bar.hs`.

### Command line options in source files

Sometimes it is useful to make the connection between a source file and the command-line options it requires quite tight. For instance, if a Haskell source file deliberately uses name shadowing, it should be compiled with the `-fno-warn-name-shadowing` option. Rather than maintaining the list of per-file options in a `Makefile`, it is possible to do this directly in the source file using the `OPTIONS_GHC` pragma
:

    {-# OPTIONS_GHC -fno-warn-name-shadowing #-}
    module X where
    ...

`OPTIONS_GHC` is a file-header pragma (see ).

Only dynamic flags can be used in an `OPTIONS_GHC` pragma (see ).

Note that your command shell does not get to the source file options, they are just included literally in the array of command-line arguments the compiler maintains internally, so you'll be desperately disappointed if you try to glob etc. inside `OPTIONS_GHC`.

NOTE: the contents of OPTIONS_GHC are appended to the command-line options, so options given in the source file override those given on the command-line.

It is not recommended to move all the contents of your Makefiles into your source files, but in some circumstances, the `OPTIONS_GHC` pragma is the Right Thing. (If you use `-keep-hc-file` and have OPTION flags in your module, the OPTIONS_GHC will get put into the generated .hc file).

### Setting options in GHCi

Options may also be modified from within GHCi, using the `:set` command. See for more details.

## Static, Dynamic, and Mode options

Each of GHC's command line options is classified as static, dynamic or mode:

Mode flags

  For example, `––make` or `-E`. There may only be a single mode flag on the command line. The available modes are listed in .

Dynamic Flags

  Most non-mode flags fall into this category. A dynamic flag may be used on the command line, in a `OPTIONS_GHC` pragma in a source file, or set using `:set` in GHCi.

Static Flags

  A few flags are "static", which means they can only be used on the command-line, and remain in force over the entire GHC/GHCi run.

The flag reference tables () lists the status of each flag.

There are a few flags that are static except that they can also be used with GHCi's `:set` command; these are listed as “static/`:set`” in the table.

## Meaningful file suffixes

File names with “meaningful” suffixes (e.g., `.lhs` or `.o`) cause the “right thing” to happen to those files.

`.hs`

  A Haskell module.

`.lhs`

  A “literate Haskell” module.

`.hi`

  A Haskell interface file, probably compiler-generated.

`.hc`

  Intermediate C file produced by the Haskell compiler.

`.c`

  A C file not produced by the Haskell compiler.

`.ll`

  An llvm-intermediate-language source file, usually produced by the compiler.

`.bc`

  An llvm-intermediate-language bitcode file, usually produced by the compiler.

`.s`

  An assembly-language source file, usually produced by the compiler.

`.o`

  An object file, produced by an assembler.

Files with other suffixes (or without suffixes) are passed straight to the linker.

## Modes of operation

GHC's behaviour is firstly controlled by a mode flag. Only one of these flags may be given, but it does not necessarily need to be the first option on the command-line.

If no mode flag is present, then GHC will enter make mode () if there are any Haskell source files given on the command line, or else it will link the objects named on the command line to produce an executable.

The available mode flags are:

    ghc --interactive

  Interactive mode, which is also available as `ghci`. Interactive mode is described in more detail in .

    ghc ––make

  In this mode, GHC will build a multi-module Haskell program automatically, figuring out dependencies for itself. If you have a straightforward Haskell program, this is likely to be much easier, and faster, than using `make`. Make mode is described in .

  This mode is the default if there are any Haskell source files mentioned on the command line, and in this case the `––make` option can be omitted.

    ghc -e
    	     expr

  Expression-evaluation mode. This is very similar to interactive mode, except that there is a single expression to evaluate (expr) which is given on the command line. See for more details.

    	    ghc -E
    	    ghc -c
    	    ghc -S
    	    ghc -c

  This is the traditional batch-compiler mode, in which GHC can compile source files one at a time, or link objects together into an executable. This mode also applies if there is no other mode flag specified on the command line, in which case it means that the specified files should be compiled and then linked to form a program. See .

                ghc -M

  Dependency-generation mode. In this mode, GHC can be used to generate dependency information suitable for use in a `Makefile`. See .

                ghc --mk-dll

  DLL-creation mode (Windows only). See .

              ghc --help ghc -?

  Cause GHC to spew a long usage message to standard output and then exit.

                ghc --show-iface file

  Read the interface in file and dump it as text to `stdout`. For example `ghc --show-iface M.hi`.

                ghc --supported-extensions
                ghc --supported-languages

  Print the supported language extensions.

                ghc --info

  Print information about the compiler.

                ghc --version
                ghc -V

  Print a one-line string including GHC's version number.

                ghc --numeric-version

  Print GHC's numeric version number only.

                ghc --print-libdir

  Print the path to GHC's library directory. This is the top of the directory tree containing GHC's libraries, interfaces, and include files (usually something like `/usr/local/lib/ghc-5.04` on Unix). This is the value of `$libdir`
  in the package configuration file (see ).

### Using `ghc` `––make`

In this mode, GHC will build a multi-module Haskell program by following dependencies from one or more root modules (usually just `Main`). For example, if your `Main` module is in a file called `Main.hs`, you could compile and link the program like this:

    ghc ––make Main.hs

In fact, GHC enters make mode automatically if there are any Haskell source files on the command line and no other mode is specified, so in this case we could just type

    ghc Main.hs

Any number of source file names or module names may be specified; GHC will figure out all the modules in the program by following the imports from these initial modules. It will then attempt to compile each module which is out of date, and finally, if there is a `Main` module, the program will also be linked into an executable.

The main advantages to using `ghc ––make` over traditional `Makefile`s are:

- GHC doesn't have to be restarted for each compilation, which means it can cache information between compilations. Compiling a multi-module program with `ghc ––make` can be up to twice as fast as running `ghc` individually on each source file.

- You don't have to write a `Makefile`.

- GHC re-calculates the dependencies each time it is invoked, so the dependencies never get out of sync with the source.

Any of the command-line options described in the rest of this chapter can be used with `––make`, but note that any options you give on the command line will apply to all the source files compiled, so if you want any options to apply to a single source file only, you'll need to use an `OPTIONS_GHC` pragma (see ).

If the program needs to be linked with additional objects (say, some auxiliary C code), then the object files can be given on the command line and GHC will include them when linking the executable.

Note that GHC can only follow dependencies if it has the source file available, so if your program includes a module for which there is no source file, even if you have an object and an interface file for the module, then GHC will complain. The exception to this rule is for package modules, which may or may not have source files.

The source files for the program don't all need to be in the same directory; the `-i` option can be used to add directories to the search path (see ).

### Expression evaluation mode

This mode is very similar to interactive mode, except that there is a single expression to evaluate which is specified on the command line as an argument to the `-e` option:

    ghc -e expr

Haskell source files may be named on the command line, and they will be loaded exactly as in interactive mode. The expression is evaluated in the context of the loaded modules.

For example, to load and run a Haskell program containing a module `Main`, we might say

    ghc -e Main.main Main.hs

or we can just use this mode to evaluate expressions in the context of the `Prelude`:

    $ ghc -e "interact (unlines.map reverse.lines)"
    hello
    olleh

### Batch compiler mode

In batch mode, GHC will compile one or more source files given on the command line.

The first phase to run is determined by each input-file suffix, and the last phase is determined by a flag. If no relevant flag is present, then go all the way through to linking. This table summarises:

Phase of the compilation system | Suffix saying “start here” | Flag saying “stop after” | (suffix of) output file
--- | --- | --- | ---
literate pre-processor | `.lhs` | - | `.hs`
C pre-processor (opt.) | `.hs` (with `-cpp`) | `-E` | `.hspp`
Haskell compiler | `.hs` | `-C`, `-S` | `.hc`, `.s`
C compiler (opt.) | `.hc` or `.c` | `-S` | `.s`
assembler | `.s` | `-c` | `.o`
linker | other | - | `a.out`

Thus, a common invocation would be:

    ghc -c Foo.hs

to compile the Haskell source file `Foo.hs` to an object file `Foo.o`.

Note: What the Haskell compiler proper produces depends on whether a native-code generator
is used (producing assembly language) or not (producing C). See for more details.

Note: C pre-processing is optional, the `-cpp`
flag turns it on. See for more details.

Note: The option `-E`
runs just the pre-processing passes of the compiler, dumping the result in a file.

#### Overriding the default behaviour for a file

As described above, the way in which a file is processed by GHC depends on its suffix. This behaviour can be overridden using the `-x` option:

`-x` suffix

  Causes all files following this option on the command line to be processed as if they had the suffix suffix. For example, to compile a Haskell module in the file `M.my-hs`, use `ghc -c -x hs M.my-hs`.

## Help and verbosity options

See also the `--help`, `--version`, `--numeric-version`, and `--print-libdir` modes in .

`-n`

  Does a dry-run, i.e. GHC goes through all the motions of compiling as normal, but does not actually run any external commands.

`-v`

  The `-v` option makes GHC verbose: it reports its version number and shows (on stderr) exactly how it invokes each phase of the compilation system. Moreover, it passes the `-v` flag to most phases; each reports its version number (and possibly some other information).

  Please, oh please, use the `-v` option when reporting bugs! Knowing that you ran the right bits in the right order is always the first thing we want to verify.

`-v` n

  To provide more control over the compiler's verbosity, the `-v` flag takes an optional numeric argument. Specifying `-v` on its own is equivalent to `-v3`, and the other levels have the following meanings:

  `-v0`

    Disable all non-essential messages (this is the default).

  `-v1`

    Minimal verbosity: print one line per compilation (this is the default when `––make` or `––interactive` is on).

  `-v2`

    Print the name of each compilation phase as it is executed. (equivalent to `-dshow-passes`).

  `-v3`

    The same as `-v2`, except that in addition the full command line (if appropriate) for each compilation phase is also printed.

  `-v4`

    The same as `-v3` except that the intermediate program representation after each compilation phase is also printed (excluding preprocessed and C/assembly files).

`-ferror-spans`

  Causes GHC to emit the full source span of the syntactic entity relating to an error message. Normally, GHC emits the source location of the start of the syntactic entity only.

  For example:

      test.hs:3:6: parse error on input `where'

  becomes:

      test296.hs:3:6-10: parse error on input `where'

  And multi-line spans are possible too:

      test.hs:(5,4)-(6,7):
          Conflicting definitions for `a'
          Bound at: test.hs:5:4
                    test.hs:6:7
          In the binding group for: a, b, a

  Note that line numbers start counting at one, but column numbers start at zero. This choice was made to follow existing convention (i.e. this is how Emacs does it).

`-H` size

  Set the minimum size of the heap to size. This option is equivalent to `+RTS -Hsize`, see .

`-Rghc-timing`

  Prints a one-line summary of timing statistics for the GHC run. This option is equivalent to `+RTS -tstderr`, see .

&separate;

## Warnings and sanity-checking

GHC has a number of options that select which types of non-fatal error messages, otherwise known as warnings, can be generated during compilation. By default, you get a standard set of warnings which are generally likely to indicate bugs in your program. These are: `-fwarn-overlapping-patterns`, `-fwarn-warnings-deprecations`, `-fwarn-deprecated-flags`, `-fwarn-duplicate-exports`, `-fwarn-missing-fields`, `-fwarn-missing-methods`, `-fwarn-lazy-unlifted-bindings`, `-fwarn-wrong-do-bind`, and `-fwarn-dodgy-foreign-imports`. The following flags are simple ways to select standard “packages” of warnings:

`-W`:

  Provides the standard warnings plus `-fwarn-incomplete-patterns`, `-fwarn-dodgy-exports`, `-fwarn-dodgy-imports`, `-fwarn-unused-matches`, `-fwarn-unused-imports`, and `-fwarn-unused-binds`.

`-Wall`:

  Turns on all warning options that indicate potentially suspicious code. The warnings that are not enabled by `-Wall` are `-fwarn-tabs`, `-fwarn-incomplete-record-updates`, `-fwarn-monomorphism-restriction`, `-fwarn-unused-do-bind`, and `-fwarn-implicit-prelude`.

`-w`:

  Turns off all warnings, including the standard ones and those that `-Wall` doesn't enable.

`-Werror`:

  Makes any warning into a fatal error. Useful so that you don't miss warnings when doing batch compilation.

`-Wwarn`:

  Warnings are treated only as warnings, not as errors. This is the default, but can be useful to negate a `-Werror` flag.

The full set of warning options is described below. To turn off any warning, simply give the corresponding `-fno-warn-...` option on the command line.

`-fwarn-unrecognised-pragmas`:

  Causes a warning to be emitted when a pragma that GHC doesn't recognise is used. As well as pragmas that GHC itself uses, GHC also recognises pragmas known to be used by other tools, e.g. `OPTIONS_HUGS` and `DERIVE`.

  This option is on by default.

`-fwarn-warnings-deprecations`:

  Causes a warning to be emitted when a module, function or type with a WARNING or DEPRECATED pragma is used. See for more details on the pragmas.

  This option is on by default.

`-fwarn-deprecated-flags`:

  Causes a warning to be emitted when a deprecated commandline flag is used.

  This option is on by default.

`-fwarn-dodgy-foreign-imports`:

  Causes a warning to be emitted for foreign imports of the following form:

      foreign import "f" f :: FunPtr t

  on the grounds that it probably should be

      foreign import "&f" f :: FunPtr t

  The first form declares that `f` is a (pure) C function that takes no arguments and returns a pointer to a C function with type `t`, whereas the second form declares that `f` itself is a C function with type `t`. The first declaration is usually a mistake, and one that is hard to debug because it results in a crash, hence this warning.

`-fwarn-dodgy-exports`:

  Causes a warning to be emitted when a datatype `T` is exported with all constructors, i.e. `T(..)`, but is it just a type synonym.

  Also causes a warning to be emitted when a module is re-exported, but that module exports nothing.

`-fwarn-dodgy-imports`:

  Causes a warning to be emitted when a datatype `T` is imported with all constructors, i.e. `T(..)`, but has been exported abstractly, i.e. `T`.

`-fwarn-lazy-unlifted-bindings`:

  Causes a warning to be emitted when an unlifted type is bound in a way that looks lazy, e.g. `where (I# x) = ...`. Use `where !(I# x) = ...` instead. This will be an error, rather than a warning, in GHC 7.2.

`-fwarn-duplicate-exports`:

  Have the compiler warn about duplicate entries in export lists. This is useful information if you maintain large export lists, and want to avoid the continued export of a definition after you've deleted (one) mention of it in the export list.

  This option is on by default.

`-fwarn-hi-shadowing`:

  Causes the compiler to emit a warning when a module or interface file in the current directory is shadowing one with the same module name in a library or other directory.

`-fwarn-implicit-prelude`:

  Have the compiler warn if the Prelude is implicitly imported. This happens unless either the Prelude module is explicitly imported with an `import ... Prelude ...` line, or this implicit import is disabled (either by `-XNoImplicitPrelude` or a `LANGUAGE NoImplicitPrelude` pragma).

  Note that no warning is given for syntax that implicitly refers to the Prelude, even if `-XNoImplicitPrelude` would change whether it refers to the Prelude. For example, no warning is given when `368` means `Prelude.fromInteger (368::Prelude.Integer)` (where `Prelude` refers to the actual Prelude module, regardless of the imports of the module being compiled).

  This warning is off by default.

`-fwarn-incomplete-patterns`:

  Similarly for incomplete patterns, the functions `g` and `h` below will fail when applied to non-empty lists, so the compiler will emit a warning about this when `-fwarn-incomplete-patterns` is enabled.

      g [] = 2
      h = \[] -> 2

  This option isn't enabled by default because it can be a bit noisy, and it doesn't always indicate a bug in the program. However, it's generally considered good practice to cover all the cases in your functions.

`-fwarn-incomplete-record-updates`:

  The function `f` below will fail when applied to `Bar`, so the compiler will emit a warning about this when `-fwarn-incomplete-record-updates` is enabled.

      data Foo = Foo { x :: Int }
               | Bar

      f :: Foo -> Foo
      f foo = foo { x = 6 }

  This option isn't enabled by default because it can be very noisy, and it often doesn't indicate a bug in the program.

`-fwarn-missing-fields`:

  This option is on by default, and warns you whenever the construction of a labelled field constructor isn't complete, missing initializers for one or more fields. While not an error (the missing fields are initialised with bottoms), it is often an indication of a programmer error.

`-fwarn-missing-methods`:

  This option is on by default, and warns you whenever an instance declaration is missing one or more methods, and the corresponding class declaration has no default declaration for them.

  The warning is suppressed if the method name begins with an underscore. Here's an example where this is useful:

      	      class C a where
      	        _simpleFn :: a -> String
      	        complexFn :: a -> a -> String
      	        complexFn x y = ... _simpleFn ...

  The idea is that: (a) users of the class will only call `complexFn`; never `_simpleFn`; and (b) instance declarations can define either `complexFn` or `_simpleFn`.
`-fwarn-missing-signatures`:

  If you would like GHC to check that every top-level function/value has a type signature, use the `-fwarn-missing-signatures` option. As part of the warning GHC also reports the inferred type. The option is off by default.

`-fwarn-name-shadowing`:

  This option causes a warning to be emitted whenever an inner-scope value has the same name as an outer-scope value, i.e. the inner value shadows the outer one. This can catch typographical errors that turn into hard-to-find bugs, e.g., in the inadvertent capture of what would be a recursive call in `f = ... let f = id in ... f ...`.

  The warning is suppressed for names beginning with an underscore. For example

                   f x = do { _ignore <- this; _ignore <- that; return (the other) }

`-fwarn-orphans`:

  This option causes a warning to be emitted whenever the module contains an "orphan" instance declaration or rewrite rule. An instance declaration is an orphan if it appears in a module in which neither the class nor the type being instanced are declared in the same module. A rule is an orphan if it is a rule for a function declared in another module. A module containing any orphans is called an orphan module.

  The trouble with orphans is that GHC must pro-actively read the interface files for all orphan modules, just in case their instances or rules play a role, whether or not the module's interface would otherwise be of any use. See for details.

`-fwarn-overlapping-patterns`:

  By default, the compiler will warn you if a set of patterns are overlapping, e.g.,

      f :: String -> Int
      f []     = 0
      f (_:xs) = 1
      f "2"    = 2

  where the last pattern match in `f` won't ever be reached, as the second pattern overlaps it. More often than not, redundant patterns is a programmer mistake/error, so this option is enabled by default.

`-fwarn-tabs`:

  Have the compiler warn if there are tabs in your source file.

  This warning is off by default.

`-fwarn-type-defaults`:

  Have the compiler warn/inform you where in your source the Haskell defaulting mechanism for numeric types kicks in. This is useful information when converting code from a context that assumed one default into one with another, e.g., the ‘default default’ for Haskell 1.4 caused the otherwise unconstrained value `1` to be given the type `Int`, whereas Haskell 98 and later defaults it to `Integer`. This may lead to differences in performance and behaviour, hence the usefulness of being non-silent about this.

  This warning is off by default.

`-fwarn-monomorphism-restriction`:

  Have the compiler warn/inform you where in your source the Haskell Monomorphism Restriction is applied. If applied silently the MR can give rise to unexpected behaviour, so it can be helpful to have an explicit warning that it is being applied.

  This warning is off by default.

`-fwarn-unused-binds`:

  Report any function definitions (and local bindings) which are unused. For top-level functions, the warning is only given if the binding is not exported.

  A definition is regarded as "used" if (a) it is exported, or (b) it is mentioned in the right hand side of another definition that is used, or (c) the function it defines begins with an underscore. The last case provides a way to suppress unused-binding warnings selectively.

  Notice that a variable is reported as unused even if it appears in the right-hand side of another unused binding.

`-fwarn-unused-imports`:

  Report any modules that are explicitly imported but never used. However, the form `import M()` is never reported as an unused import, because it is a useful idiom for importing instance declarations, which are anonymous in Haskell.

`-fwarn-unused-matches`:

  Report all unused variables which arise from pattern matches, including patterns consisting of a single variable. For instance `f x y = []` would report `x` and `y` as unused. The warning is suppressed if the variable name begins with an underscore, thus:

      	       f _x = True

`-fwarn-unused-do-bind`:

  Report expressions occuring in `do` and `mdo` blocks that appear to silently throw information away. For instance `do { mapM popInt xs ; return 10 }` would report the first statement in the `do` block as suspicious, as it has the type `StackM [Int]` and not `StackM ()`, but that `[Int]` value is not bound to anything. The warning is suppressed by explicitly mentioning in the source code that your program is throwing something away:

      	       do { _ <- mapM popInt xs ; return 10 }

  Of course, in this particular situation you can do even better:

      	       do { mapM_ popInt xs ; return 10 }

`-fwarn-wrong-do-bind`:

  Report expressions occuring in `do` and `mdo` blocks that appear to lack a binding. For instance `do { return (popInt 10) ; return 10 }` would report the first statement in the `do` block as suspicious, as it has the type `StackM (StackM Int)` (which consists of two nested applications of the same monad constructor), but which is not then "unpacked" by binding the result. The warning is suppressed by explicitly mentioning in the source code that your program is throwing something away:

      	       do { _ <- return (popInt 10) ; return 10 }

  For almost all sensible programs this will indicate a bug, and you probably intended to write:

      	       do { popInt 10 ; return 10 }

If you're feeling really paranoid, the `-dcore-lint` option
is a good choice. It turns on heavyweight intra-pass sanity-checking within GHC. (It checks GHC's sanity, not yours.)

&packages;

## Optimisation (code improvement)

The `-O*` options specify convenient “packages” of optimisation flags; the `-f*` options described later on specify individual optimisations to be turned on/off; the `-m*` options specify machine-specific optimisations to be turned on/off.

### `-O*`: convenient “packages” of optimisation flags.

There are many options that affect the quality of code produced by GHC. Most people only have a general goal, something like “Compile quickly” or “Make my program run like greased lightning.” The following “packages” of optimisations (or lack thereof) should suffice.

Note that higher optimisation levels cause more cross-module optimisation to be performed, which can have an impact on how much of your program needs to be recompiled when you change something. This is one reason to stick to no-optimisation when developing code.

No `-O*`-type option specified:

  This is taken to mean: “Please compile quickly; I'm not over-bothered about compiled-code quality.” So, for example: `ghc -c Foo.hs`

`-O0`:

  Means “turn off all optimisation”, reverting to the same settings as if no `-O` options had been specified. Saying `-O0` can be useful if eg. `make` has inserted a `-O` on the command line already.

`-O` or `-O1`:

  Means: “Generate good-quality code without taking too long about it.” Thus, for example: `ghc -c -O Main.lhs`

`-O2`:

  Means: “Apply every non-dangerous optimisation, even if it means significantly longer compile times.”

  The avoided “dangerous” optimisations are those that can make runtime or space worse if you're unlucky. They are normally turned on or off individually.

  At the moment, `-O2` is unlikely to produce better code than `-O`.

`-Ofile <file>`:

  (NOTE: not supported since GHC 4.x. Please ask if you're interested in this.)

  For those who need absolute control over exactly what options are used (e.g., compiler writers, sometimes :-), a list of options can be put in a file and then slurped in with `-Ofile`.

  In that file, comments are of the `&num;`-to-end-of-line variety; blank lines and most whitespace is ignored.

  Please ask if you are baffled and would like an example of `-Ofile`!

We don't use a `-O*` flag for day-to-day work. We use `-O` to get respectable speed; e.g., when we want to measure something. When we want to go for broke, we tend to use `-O2 -fvia-C` (and we go for lots of coffee breaks).

The easiest way to see what `-O` (etc.) “really mean” is to run with `-v`, then stand back in amazement.

### `-f*`: platform-independent flags

These flags turn on and off individual optimisations. They are normally set via the `-O` options described above, and as such, you shouldn't need to set any of them explicitly (indeed, doing so could lead to unexpected results). However, there are one or two that may be of interest:

`-fexcess-precision`:

  When this option is given, intermediate floating point values can have a greater precision/range than the final type. Generally this is a good thing, but some programs may rely on the exact precision/range of `Float`/`Double` values and should not use this option for their compilation.

`-fignore-asserts`:

  Causes GHC to ignore uses of the function `Exception.assert` in source code (in other words, rewriting `Exception.assert p e` to `e` (see ). This flag is turned on by `-O`.

`-fno-cse`

  Turns off the common-sub-expression elimination optimisation. Can be useful if you have some `unsafePerformIO` expressions that you don't want commoned-up.

`-fno-strictness`

  Turns off the strictness analyser; sometimes it eats too many cycles.

`-fno-full-laziness`

  Turns off the full laziness optimisation (also known as let-floating). Full laziness increases sharing, which can lead to increased memory residency.

  NOTE: GHC doesn't implement complete full-laziness. When optimisation in on, and `-fno-full-laziness` is not given, some transformations that increase sharing are performed, such as extracting repeated computations from a loop. These are the same transformations that a fully lazy implementation would do, the difference is that GHC doesn't consistently apply full-laziness, so don't rely on it.

`-fno-float-in`

  Turns off the float-in transformation.

`-fno-specialise`

  Turns off the automatic specialisation of overloaded functions.

`-fspec-constr`

  Turn on call-pattern specialisation.

`-fliberate-case`

  Turn on the liberate-case transformation.

`-fstatic-argument-transformation`

  Turn on the static argument transformation.

`-fno-state-hack`

  Turn off the "state hack" whereby any lambda with a `State#` token as argument is considered to be single-entry, hence it is considered OK to inline things inside it. This can improve performance of IO and ST monad code, but it runs the risk of reducing sharing.

`-fomit-interface-pragmas`

  Tells GHC to omit all inessential information from the interface file generated for the module being compiled (say M). This means that a module importing M will see only the types of the functions that M exports, but not their unfoldings, strictness info, etc. Hence, for example, no function exported by M will be inlined into an importing module. The benefit is that modules that import M will need to be recompiled less often (only when M's exports change their type, not when they change their implementation).

`-fignore-interface-pragmas`

  Tells GHC to ignore all inessential information when reading interface files. That is, even if `M.hi` contains unfolding or strictness information for a function, GHC will ignore that information.

`-funbox-strict-fields`:

  This option causes all constructor fields which are marked strict (i.e. “!”) to be unboxed or unpacked if possible. It is equivalent to adding an `UNPACK` pragma to every strict constructor field (see ).

  This option is a bit of a sledgehammer: it might sometimes make things worse. Selectively unboxing fields by using `UNPACK` pragmas might be better.

`-funfolding-creation-threshold=n`:

  (Default: 45) Governs the maximum size that GHC will allow a function unfolding to be. (An unfolding has a “size” that reflects the cost in terms of “code bloat” of expanding that unfolding at at a call site. A bigger function would be assigned a bigger cost.)

  Consequences: (a) nothing larger than this will be inlined (unless it has an INLINE pragma); (b) nothing larger than this will be spewed into an interface file.

  Increasing this figure is more likely to result in longer compile times than faster code. The next option is more useful:

`-funfolding-use-threshold=n`

  (Default: 8) This is the magic cut-off figure for unfolding: below this size, a function definition will be unfolded at the call-site, any bigger and it won't. The size computed for a function depends on two things: the actual size of the expression minus any discounts that apply (see `-funfolding-con-discount`).

&phases;

&shared_libs;

## Using Concurrent Haskell

GHC supports Concurrent Haskell by default, without requiring a special option or libraries compiled in a certain way. To get access to the support libraries for Concurrent Haskell, just import `Control.Concurrent`. More information on Concurrent Haskell is provided in the documentation for that module.

The following RTS option(s) affect the behaviour of Concurrent Haskell programs:

`-Cs`

  Sets the context switch interval to s seconds. A context switch will occur at the next heap block allocation after the timer expires (a heap block allocation occurs every 4k of allocation). With `-C0` or `-C`, context switches will occur as often as possible (at every heap block allocation). By default, context switches occur every 20ms.

## Using SMP parallelism

GHC supports running Haskell programs in parallel on an SMP (symmetric multiprocessor).

There's a fine distinction between concurrency and parallelism: parallelism is all about making your program run faster by making use of multiple processors simultaneously. Concurrency, on the other hand, is a means of abstraction: it is a convenient way to structure a program that must respond to multiple asynchronous events.

However, the two terms are certainly related. By making use of multiple CPUs it is possible to run concurrent threads in parallel, and this is exactly what GHC's SMP parallelism support does. But it is also possible to obtain performance improvements with parallelism on programs that do not use concurrency. This section describes how to use GHC to compile and run parallel programs, in we describe the language features that affect parallelism.

### Compile-time options for SMP parallelism

In order to make use of multiple CPUs, your program must be linked with the `-threaded` option (see ). Additionally, the following compiler options affect parallelism:

`-feager-blackholing`

  Blackholing is the act of marking a thunk (lazy computuation) as being under evaluation. It is useful for three reasons: firstly it lets us detect certain kinds of infinite loop (the `NonTermination` exception), secondly it avoids certain kinds of space leak, and thirdly it avoids repeating a computation in a parallel program, because we can tell when a computation is already in progress.

  The option `-feager-blackholing` causes each thunk to be blackholed as soon as evaluation begins. The default is "lazy blackholing", whereby thunks are only marked as being under evaluation when a thread is paused for some reason. Lazy blackholing is typically more efficient (by 1-2&percnt; or so), because most thunks don't need to be blackholed. However, eager blackholing can avoid more repeated computation in a parallel program, and this often turns out to be important for parallelism.

  We recommend compiling any code that is intended to be run in parallel with the `-feager-blackholing` flag.

### RTS options for SMP parallelism

To run a program on multiple CPUs, use the RTS `-N` option:

`-Nx`

  Use x simultaneous threads when running the program. Normally x should be chosen to match the number of CPU cores on the machine Whether hyperthreading cores should be counted or not is an open question; please feel free to experiment and let us know what results you find.. For example, on a dual-core machine we would probably use `+RTS -N2 -RTS`.

  Omitting x, i.e. `+RTS -N -RTS`, lets the runtime choose the value of x itself based on how many processors are in your machine.

  Be careful when using all the processors in your machine: if some of your processors are in use by other programs, this can actually harm performance rather than improve it.

  Setting `-N` also has the effect of enabling the parallel garbage collector (see ).

  There is no means (currently) by which this value may vary after the program has started.

  The current value of the `-N` option is available to the Haskell program via `GHC.Conc.numCapabilities`.

The following options affect the way the runtime schedules threads on CPUs:

`-qa`

  Use the OS's affinity facilities to try to pin OS threads to CPU cores. This is an experimental feature, and may or may not be useful. Please let us know whether it helps for you!

`-qm`

  Disable automatic migration for load balancing. Normally the runtime will automatically try to schedule threads across the available CPUs to make use of idle CPUs; this option disables that behaviour. Note that migration only applies to threads; sparks created by `par` are load-balanced separately by work-stealing.

  This option is probably only of use for concurrent programs that explicitly schedule threads onto CPUs with `GHC.Conc.forkOnIO`.

`-qw`

  Migrate a thread to the current CPU when it is woken up. Normally when a thread is woken up after being blocked it will be scheduled on the CPU it was running on last; this option allows the thread to immediately migrate to the CPU that unblocked it.

  The rationale for allowing this eager migration is that it tends to move threads that are communicating with each other onto the same CPU; however there are pathalogical situations where it turns out to be a poor strategy. Depending on the communication pattern in your program, it may or may not be a good idea.

### Hints for using SMP parallelism

Add the `-s` RTS option when running the program to see timing stats, which will help to tell you whether your program got faster by using more CPUs or not. If the user time is greater than the elapsed time, then the program used more than one CPU. You should also run the program without `-N` for comparison.

The output of `+RTS -s` tells you how many “sparks” were created and executed during the run of the program (see ), which will give you an idea how well your `par` annotations are working.

GHC's parallelism support has improved in 6.12.1 as a result of much experimentation and tuning in the runtime system. We'd still be interested to hear how well it works for you, and we're also interested in collecting parallel programs to add to our benchmarking suite.

## Platform-specific Flags

Some flags only make sense for particular target platforms.

`-msse2`:

  (x86 only, added in GHC 7.0.1) Use the SSE2 registers and instruction set to implement floating point operations when using the native code generator. This gives a substantial performance improvement for floating point, but the resulting compiled code will only run on processors that support SSE2 (Intel Pentium 4 and later, or AMD Athlon 64 and later).

  SSE2 is unconditionally used on x86-64 platforms.

`-monly-[32]-regs`:

  (x86 only)
  GHC tries to “steal” four registers from GCC, for performance reasons; it almost always works. However, when GCC is compiling some modules with four stolen registers, it will crash, probably saying:

      Foo.hc:533: fixed or forbidden register was spilled.
      This may be due to a compiler bug or to impossible asm
      statements or clauses.

  Just give some registers back with `-monly-N-regs`. Try `3' first, then `2'. If `2' doesn't work, please report the bug to us.

&runtime;

## Generating and compiling External Core Files

GHC can dump its optimized intermediate code (said to be in “Core” format) to a file as a side-effect of compilation. Non-GHC back-end tools can read and process Core files; these files have the suffix `.hcr`. The Core format is described in An External Representation for the GHC Core Language, and sample tools for manipulating Core files (in Haskell) are available in the extcore package on Hackage. Note that the format of `.hcr` files is different from the Core output format that GHC generates for debugging purposes (), though the two formats appear somewhat similar.

The Core format natively supports notes which you can add to your source code using the `CORE` pragma (see ).

`-fext-core`

  Generate `.hcr` files.

Currently (as of version 6.8.2), GHC does not have the ability to read in External Core files as source. If you would like GHC to have this ability, please make your wishes known to the GHC Team.

&debug; &flags;